import Axios from 'axios'

const defaultHeaders = {
  Accept: 'application/json, text/plain, */*; charset=utf-8',
  'Content-Type': 'application/json; charset=utf-8',
  Pragma: 'no-cache',
  'Cache-Control': 'no-cache',
  'X-Requested-With': 'XMLHttpRequest',
}

Object.assign(Axios.defaults.headers.common, defaultHeaders)

const methods = ['get', 'post', 'put', 'delete']

let http = {}
methods.forEach((method) => {
  http[method] = Axios[method].bind(Axios)
})

export function createAxios ({
  baseURL='/api', // 基础路由
  timeout=30000, // 超时
  withCredentials=true, // 是否允许带cookie这些
  tokenName='token', // localStorage中token名字
  ...options
}) {
  Axios.defaults.baseURL = baseURL
  Axios.defaults.timeout = timeout

  if (global.localStorage && global.localStorage.getItem(tokenName)) {
    Axios.defaults.headers.common.Authorization = global.localStorage.getItem(tokenName)
  }

  return http
}

export const addRequestInterceptor =
  Axios.interceptors.request.use.bind(Axios.interceptors.request)

export const addResponseInterceptor =
  Axios.interceptors.response.use.bind(Axios.interceptors.response)
