const path = require('path')
//一个抽离出css的webpack插件！
// const ExtractTextPlugin = require('extract-text-webpack-plugin')

exports.cssLoader = function ({ sourceMap = false, extract = false }) {
  function generateLoaders(loader, loaderOpts) {
    const loaders = [
      { //默认loader
        loader: 'css-loader',
        options: {
          minimize: process.env.NODE_ENV === 'production',
          // sourceMap: opts.sourceMap,
        },
      },
      { //默认loader
        loader: 'postcss-loader',
        options: {
          sourceMap: true,
        },
      },
    ]

    if (loader) {
      loaders.push({
        loader: `${loader}-loader`,
        options: Object.assign({}, loaderOpts, {
          // sourceMap: opts.sourceMap,
        })
      })
    }

    if (extract) { //是否需要抽离css
      // ExtractTextPlugin.extract({
      //   use: loaders,
      //   fallback: 'vue-style-loader',
      //   publicPath: '/' //抽离出来的css 添加路径前缀, 让其打包出来的路径正确
      // })
    }

    return ['vue-style-loader'].concat(loaders)
  }

  return {
    css: generateLoaders(),
    stylus: generateLoaders('stylus'),
  }
}