const path = require('path')
const webpack = require('webpack')
const { projectPath } = require('../utils')

const vendor = [
  'vue/dist/vue.esm.js',
  'axios',
]

module.exports = {
  mode: 'none',
  entry: {
    vendor,
  },
  output: {
    path: `${projectPath}/static`,
    filename: '[name].dll.js',
    library: '[name]_library',
  },
  plugins: [
    new webpack.DllPlugin({
      path: `${projectPath}/vendor_manifest.json`,
      name: '[name]_library',
    })
  ],
  optimization: {
    minimize: true,
  },
}