const webpack = require('webpack')
const merge = require('webpack-merge')
const webpackBase = require('./webpack.base.config')
const { projectPath } = require('../utils')
const WorkboxPlugin = require('workbox-webpack-plugin')

module.exports = merge(webpackBase, {
  output: {
    filename: '[name]_[hash:6].js',
    path: `${projectPath}/public`,
  },
  plugins: [
    new webpack.DefinePlugin({
      'process.env': {
        NODE_ENV: '"production"',
      },
    }),
    new WorkboxPlugin.GenerateSW({
      // 这些选项帮助 ServiceWorkers 快速启用
      // 不允许遗留任何“旧的” ServiceWorkers
      clientsClaim: true,
      skipWaiting: true
    }),
  ],
  optimization: {
    minimize: true,
  },
})