const Express = require('express')
const WorkboxPlugin = require('workbox-webpack-plugin')

const appConfig = require('../utils/get-app-config')

const webpackDevMiddleware = require('./middlewares/webpack.dev')
const proxyMiddleware = require('./middlewares/proxy')

module.exports = function createApp(options, onStart = () => {}) {
  const app = Express()

  app.use(Express.static('public'))

  if (process.env.NODE_ENV === 'development') {
    webpackDevMiddleware(app)
  }

  // proxy配置
  app.use(proxyMiddleware)

  app.listen(appConfig.appPort, function () {
    console.log(`server is running in http://localhost:${appConfig.appPort}`)
  })

  // 服务器启动回调
  onStart()

  return app
}