const path = require('path')
const webpack = require('webpack')
const webpackDevMiddleware = require('webpack-dev-middleware')
const webpackHotMiddleware = require('webpack-hot-middleware')

const clientConfig = require('../../config/webpack.dev.config')

module.exports = function setupDevServer (app, templatePath, cb) {
  clientConfig.entry.app = ['webpack-hot-middleware/client', clientConfig.entry.app]
  clientConfig.output.filename = '[name].js'
  clientConfig.plugins.push(
    new webpack.HotModuleReplacementPlugin(),
    new webpack.NoEmitOnErrorsPlugin()
  )

  const clientCompiler = webpack(clientConfig)
  // dev middleware
  const devMiddleware = webpackDevMiddleware(clientCompiler, {
    // publicPath: clientConfig.output.publicPath,
    noInfo: true,
    reload: true,
    headers: { 'Access-Control-Allow-Origin': '*' },
    stats: {
      colors: true,
      chunks: false,
    },
    serverSideRender: false, //  关闭服务器端渲染模式。有关详细信息，请参阅服务器端渲染部分
  })
  app.use(devMiddleware)

  app.use(webpackHotMiddleware(clientCompiler))
}