const webpack = require('webpack')
const WebpackDevServer = require('webpack-dev-server')

const appConfig = require('../utils/get-app-config')
const webpackConfig = require('../config/webpack.dev.config')

// reload
Object.keys(webpackConfig.entry).forEach(function (key) {
  webpackConfig.entry[key] = [
    `webpack-dev-server/client?${appConfig.webpackServerPath}`,
    webpackConfig.entry[key],
  ]
})

const compiler = webpack(webpackConfig)
const server = new WebpackDevServer(compiler, {
  headers: { 'Access-Control-Allow-Origin': '*' },
  historyApiFallback: false,
  compress: true,
  stats: {
    colors: true,
    chunks: false,
  },
})

server.listen(appConfig.webpackDevServerPort, appConfig.currentIP, () => {
  console.log(`Webpack server listening at ${appConfig.webpackServerPath}`)
})